/*
 *
 * Copyright (C) 2004, Laszlo Peter
 *
 * Nautilus is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * Nautilus is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * Authors: Laszlo Peter <laca@sun.com>
 *
 */

const char blocks[20][4][4] = {
    {
	{0, 0, 0, 0},
	{0, 0, 0, 0},
	{0, 0, 0, 0},
	{0, 0, 0, 0},
    },
    {
	{0, 1, 1, 0},
	{0, 1, 1, 0},
	{0, 0, 0, 0},
	{0, 0, 0, 0},
    },
    {
	{1, 1, 1, 1},
	{0, 0, 0, 0},
	{0, 0, 0, 0},
	{0, 0, 0, 0},
    },
    {
	{0, 0, 1, 0},
	{0, 0, 1, 0},
	{0, 0, 1, 0},
	{0, 0, 1, 0},
    },
    {
	{0, 0, 1, 1},
	{0, 1, 1, 0},
	{0, 0, 0, 0},
	{0, 0, 0, 0},
    },
    {
	{0, 1, 0, 0},
	{0, 1, 1, 0},
	{0, 0, 1, 0},
	{0, 0, 0, 0},
    },
    {
	{0, 1, 1, 0},
	{0, 0, 1, 1},
	{0, 0, 0, 0},
	{0, 0, 0, 0},
    },
    {
	{0, 0, 1, 0},
	{0, 1, 1, 0},
	{0, 1, 0, 0},
	{0, 0, 0, 0},
    },
    {
	{0, 1, 1, 1},
	{0, 1, 0, 0},
	{0, 0, 0, 0},
	{0, 0, 0, 0},
    },
    {
	{0, 1, 0, 0},
	{0, 1, 0, 0},
	{0, 1, 1, 0},
	{0, 0, 0, 0},
    },
    {
	{0, 0, 0, 1},
	{0, 1, 1, 1},
	{0, 0, 0, 0},
	{0, 0, 0, 0},
    },
    {
	{0, 1, 1, 0},
	{0, 0, 1, 0},
	{0, 0, 1, 0},
	{0, 0, 0, 0},
    },
    {
	{0, 1, 1, 1},
	{0, 0, 0, 1},
	{0, 0, 0, 0},
	{0, 0, 0, 0},
    },
    {
	{0, 1, 1, 0},
	{0, 1, 0, 0},
	{0, 1, 0, 0},
	{0, 0, 0, 0},
    },
    {
	{0, 1, 0, 0},
	{0, 1, 1, 1},
	{0, 0, 0, 0},
	{0, 0, 0, 0},
    },
    {
	{0, 0, 1, 0},
	{0, 0, 1, 0},
	{0, 1, 1, 0},
	{0, 0, 0, 0},
    },
    {
	{0, 1, 1, 1},
	{0, 0, 1, 0},
	{0, 0, 0, 0},
	{0, 0, 0, 0},
    },
    {
	{0, 1, 0, 0},
	{0, 1, 1, 0},
	{0, 1, 0, 0},
	{0, 0, 0, 0},
    },
    {
	{0, 0, 1, 0},
	{0, 1, 1, 1},
	{0, 0, 0, 0},
	{0, 0, 0, 0},
    },
    {
	{0, 0, 1, 0},
	{0, 1, 1, 0},
	{0, 0, 1, 0},
	{0, 0, 0, 0},
    }
};

const int bottoms[20][4] = {
    {-1, -1, -1, -1},
    {-1, 1, 1, -1},
    {0, 0, 0, 0},
    {-1, -1, 3, -1},
    {-1, 1, 1, 0},
    {-1, 1, 2, -1},
    {-1, 0, 1, 1},
    {-1, 2, 1, -1},
    {-1, 1, 0, 0},
    {-1, 2, 2, -1},
    {-1, 1, 1, 1},
    {-1, 0, 2, -1},
    {-1, 0, 0, 1},
    {-1, 2, 0, -1},
    {-1, 1, 1, 1},
    {-1, 2, 2, -1},
    {-1, 0, 1, 0},
    {-1, 2, 1, -1},
    {-1, 1, 1, 1},
    {-1, 1, 2, -1}
};

const static char max_rotations[20] = {
    /* TC_BLOCK_NONE 0 */  0,
    /* TC_BLOCK_O    1 */  0,
    /* TC_BLOCK_I_1  2 */  1,
    /* TC_BLOCK_I_2  3 */  1,
    /* TC_BLOCK_S_1  4 */  1,
    /* TC_BLOCK_S_2  5 */  1,
    /* TC_BLOCK_Z_1  6 */  1,
    /* TC_BLOCK_Z_2  7 */  1,
    /* TC_BLOCK_L_1  8 */  3,
    /* TC_BLOCK_L_2  9 */  3,
    /* TC_BLOCK_L_3  10 */ 3,
    /* TC_BLOCK_L_4  11 */ 3,
    /* TC_BLOCK_J_1  12 */ 3,
    /* TC_BLOCK_J_2  13 */ 3,
    /* TC_BLOCK_J_3  14 */ 3,
    /* TC_BLOCK_J_4  15 */ 3,
    /* TC_BLOCK_T_1  16 */ 3,
    /* TC_BLOCK_T_2  17 */ 3,
    /* TC_BLOCK_T_3  18 */ 3,
    /* TC_BLOCK_T_4  19 */ 3
};

const static char rotate_cw[20] = {
    /* TC_BLOCK_NONE 0 */  TC_BLOCK_NONE,
    /* TC_BLOCK_O    1 */  TC_BLOCK_O,
    /* TC_BLOCK_I_1  2 */  TC_BLOCK_I_2,
    /* TC_BLOCK_I_2  3 */  TC_BLOCK_I_1,
    /* TC_BLOCK_S_1  4 */  TC_BLOCK_S_2,
    /* TC_BLOCK_S_2  5 */  TC_BLOCK_S_1,
    /* TC_BLOCK_Z_1  6 */  TC_BLOCK_Z_2,
    /* TC_BLOCK_Z_2  7 */  TC_BLOCK_Z_1,
    /* TC_BLOCK_L_1  8 */  TC_BLOCK_L_2,
    /* TC_BLOCK_L_2  9 */  TC_BLOCK_L_3,
    /* TC_BLOCK_L_3  10 */ TC_BLOCK_L_4,
    /* TC_BLOCK_L_4  11 */ TC_BLOCK_L_1,
    /* TC_BLOCK_J_1  12 */ TC_BLOCK_J_2,
    /* TC_BLOCK_J_2  13 */ TC_BLOCK_J_3,
    /* TC_BLOCK_J_3  14 */ TC_BLOCK_J_4,
    /* TC_BLOCK_J_4  15 */ TC_BLOCK_J_1,
    /* TC_BLOCK_T_1  16 */ TC_BLOCK_T_2,
    /* TC_BLOCK_T_2  17 */ TC_BLOCK_T_3,
    /* TC_BLOCK_T_3  18 */ TC_BLOCK_T_4,
    /* TC_BLOCK_T_4  19 */ TC_BLOCK_T_1
};

